<?php
require_once 'config.php';
require_once 'functions.php';

function scanFolders($dir) {
    $folders = [];
    foreach (new DirectoryIterator($dir) as $fileInfo) {
        if ($fileInfo->isDot()) continue;
        if ($fileInfo->isDir()) {
            $folderName = $fileInfo->getFilename();
            $tags = extractTags($folderName);
            $folders[] = [
                'name' => $folderName,
                'tags' => $tags
            ];
        }
    }
    return $folders;
}

function extractTags($folderName) {
    $tags = [];
    $parts = explode(' ', $folderName);
    foreach ($parts as $part) {
        if (substr($part, 0, 1) === '#') {
            $tag = substr($part, 1);
            if (mb_strlen($tag, 'UTF-8') <= 12) {
                $tags[] = $tag;
            }
        }
    }
    return $tags;
}

$folders = scanFolders(ROOT_DIR);

// 将结果保存到 JSON 文件
file_put_contents(CACHE_DIR . '/folders.json', json_encode($folders));

echo "扫描完成，共发现 " . count($folders) . " 个文件夹。";
